/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 */
package com.jcg.randomsetelementthreadlocal;

import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ThreadLocalRandom;

/**
 *
 * @author omozegieaziegbe
 */
public class RandomSetElementThreadLocal {

    public static void main(String[] args) {
        // Create a Set (e.g., HashSet)
        Set<String> fruits = new HashSet<>();
        fruits.add("orange");
        fruits.add("banana");
        fruits.add("apple");
        fruits.add("guava");
        fruits.add("pineapple");

        // Use ThreadLocalRandom to get a random element
        int randomIndex = ThreadLocalRandom.current().nextInt(fruits.size());

        // Use an iterator to get the element at the random index
        String randomFruit = getRandomElement(fruits, randomIndex);

        // Print the random element
        System.out.println("Random Fruit: " + randomFruit);
    }

    // Helper method to get the element at a specific index in a Set
    private static <T> T getRandomElement(Set<T> set, int index) {
        int currentIndex = 0;
        for (T element : set) {
            if (currentIndex == index) {
                return element;
            }
            currentIndex++;
        }
        throw new IndexOutOfBoundsException("Index: " + index + ", Size: " + set.size());
    }
}
